static char sccs_defines_h[] = "@(#)defines.h	1.1 10/16/90 11:11:02 LLNL ";
/***********************************************************************
 * This file gives the global DEFINE's for the gmat tool
 **********************************************************************/

/* ******************************************************************** */
/*   (c) Copyright 1987 the Regents of the University of California,	*/
/*    Lawrence Livermore National Laboratory.  All Rights Reserved.	*/
/* ******************************************************************** */


/*
 * Copyright Cray Research, Inc.  Unpublished.  All rights reserved.

 * Cray Research warrants and provides support for this software
 * only when distributed and used under the terms of a license
 * agreement with Cray Research.

 * FOR PRODUCT DISTRIBUTED IN ANY OTHER MANNER, CRAY RESEARCH DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL 
 * CRAY RESEARCH BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA
 * OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OF
 * THIS SOFTWARE.
*/


#define MAXTASKS	3000	/* maximum number of tasks */
#define MAXPROCS	16	/* maximum number of processors */
#define MAXWAIT		5000	/* maximum wait for the for loop */
#define SAVEACTIONS	5	/* number of past actions to be saved */

#define XOFFSET         15      /* x offset into pixrect */
#define TOPOFFSET       3       /* offset to top of node */
#define BOTOFFSET       28      /* offset to bottom of node */
#define NODEDIM         32	/* size of circle rect */
#define REVDIM          31	/* size for reverse-video */
#define BOXWIDTH        112     /* actually you see 111 x 60 */
#define BOXHEIGHT       60
#define VIEWWIDTH	950	/* width of view of primary canvas */
#define VIEWHEIGHT	585	/* height of view of primary canvas */
#define OVSQUARE	5	/* dimension of square in overview */
#define PCSQUARE	50	/* dimension of square in primary canvas */
#define SCALEUP		10	/* to scale from the overview to the primary canvas */
#define SCALEDOWN	0.1	/* to scale from the primary canvas to the overview */
#define PCX		3800	/* x dimension of primary canvas */
#define PCY		2800	/* y dimension of primary canvas */
#define OVX		383	/* x dimension of overview canvas */
#define OVY		283	/* y dimension of overview canvas */
#define HISTX		pw2->pw_prretained->pr_size.x
#define HISTY		pw2->pw_prretained->pr_size.y
#define SPACEHIST	4	/* number of pixels between events */
#define MAXHIST		10000	/* total length of histogram - in pixels */
#define PROCDIM		64      /* dimension of process icon */
#define BORDER          25      /* screen border in primary canvas */
#define INFOX		175	/* width of node info canvas */
#define INFOY		200	/* height of node info canvas */


/* action numbers */
#ifdef CTSSTRACE
#define LIGHT		128	/* And Then There Was Light . . . */
#define START		129	/* Start Task */
#define COMPLETED	130	/* Complete Task */
#define RECOVER		131	/* Recover Task */
#define BIND		132	/* Bind Task to Process */
#define UNBIND		133	/* Unbind Task from Process */
#define REQUEST		144	/* Request New Process */
#define ACQUIRE		145	/* Acquire new Process */
#define IDLE		146	/* Idle a Process */
#define SUSPEND		147	/* Suspend a Process */
#define RELEASE		148	/* Release a Process */
#define REQSUS		149	/* Request Suspended Process */
#define REACQUIRE	150	/* Reacquire a Process */
#define TWAIT		160	/* Wait on a Task */
#define LWAIT		161	/* Wait on a Lock */
#define EWAIT		162	/* Wait on an Event */
#define TNWAIT		163	/* No Wait on a Task */
#define LNWAIT		164	/* No Wait on a Lock */
#define ENWAIT		165	/* No Wait on an Event */
#define TRESUME		166	/* Resume after Wait on Task */
#define LRESUME		167	/* Resume after Wait on Lock */
#define ERESUME		168	/* Resume after Wait on Event */
#define ECLEAR		169	/* Clear an Event */
#define EPOST		170 	/* Post an Event */
#define LASSIGN		171	/* Assign a Lock */
#define EASSIGN		172	/* Assign a Lock */
#define LRELEASE 	173	/* Release a Lock */
#define ERELEASE	174	/* Release Event */
#define LCLEAR		175	/* Clear Lock */
#define TTEST		176	/* Test a Task */
#define LTEST		177	/* Test a Lock */
#define ETEST		178	/* Test an Event */
#define BASSIGN		179	/* Assign a Barrier */
#define BRELEASE	180	/* Release a Barrier */
#define BWAIT		181	/* Wait on a Barrier */
#define BNWAIT		182	/* No Wait on a Barrier */
#define BRESUME		183	/* Resume after Wait on Barrier */
#define GNWAIT		256	/* Wait for Guard N */
#define GNRESUME	257	/* Resume after Guard N */
#define GWAIT		258	/* Wait for Guard */
#define GRESUME		259	/* Resume after Guard */
#define SINIT		260	/* Initialize Slaves */
#define MSTARTF		261 	/* Master Starts Fray */
#define MWAITF		262	/* Master Waits for Fray Done */
#define MRESUMEF	263	/* Master Resumes after Fray */
#define CSWAIT		264	/* Wait for Control Structure Done */
#define CSNWAIT		265	/* No Wait for Control Structure */
#define CSRESUME	266	/* Resume after Control Structure */
#define SWAITW		267	/* Slave Waits For Work */
#define SSTARTF		268	/* Slave Starts Fray */
#define SEXIT		269	/* Slave Exits */
#define LOST		1023	/* Logging items lost */
#define BARRIER         13      /* Temporary log for barriers ss */
#endif CTSSTRACE

#ifdef CRAYTRACE
#define START		0  	/* TSKST - Start Task */
#define COMPLETED	1  	/* TSKCM - Complete Task */
#define TNWAIT         2       /* TSKWT - TSKWAIT, nowait */
#define TWAIT          3       /* TSKWTB - begin wait for task */
#define TRESUME        4       /* TSKWTE - run after wait for task */
#define TTEST          5       /* TSKTST - test task */

#define LASSIGN        6       /* LCKASN - assign lock */
#define LRELEASE       7       /* LCKREL - release lock */
#define LNWAIT         8       /* LCKSET - set lock */
#define LWAIT          9       /* LCKWTB - begin wait to set lock */
#define LRESUME       10       /* LCKWTE - run after wait for lock */
#define LCLEAR        11       /* LCKCLR - clear lock */
#define LTEST         12       /* LCKTST - test lock */

#define EASSIGN       13       /* EVASGN - assign event */
#define ERELEASE      14       /* EVREL - release event */
#define EPOST         15       /* EVPOST - post event */
#define ECLEAR        16       /* EVCLR - clear event */
#define ENWAIT        17       /* EVWAIT - EVWAIT, no wait */
#define EWAIT         18       /* EVWTB - begin wait for event */
#define ERESUME       19       /* EVWTE - run after wait for event */
#define ETEST         20       /* EVTEST - test event */

#define BIND          21       /* CPUATT - attach to logical CPU */
#define UNBIND        22       /* CPUDET - detach from logical CPU */
#define REQUEST       23       /* CPUREQ - request a logical CPU */
#define REQUEST_NA    24       /* CPUREQ+1 - COS only - no-abort on CPUREQ */
#define ACQUIRE       25       /* CPUACQ - acquire a logical CPU */
#define RELEASE       26       /* CPUDEL - release a logical CPU */
#define RELEASE_NA    27       /* CPUDEL+1 - COS only - no-abort on CPUDEL */
#define SUSPEND       28       /* CPUSUS - suspend a logical CPU */
#define SUSPEND_NA    29       /* CPUSUS+1 - COS only - no-abort on CPUSUS */
#define REQSUS        30       /* CPUACT - activate a logical CPU */
#define REQSUS_NA     31       /* CPUACT+1 - COS only - no-abort on CPUACT */
#define IDLE          32       /* CPUHLD - delay a logical CPU */

#define BASSIGN       33       /* BRASGN - assign a barrier */
#define BRELEASE      34       /* BRREL - release a barrier */
#define BNWAIT        35       /* BRSYNC - sync at a barrier, no wait */
#define BWAIT         36       /* BRWTB - barrier sync, start wait */
#define BRESUME       37       /* BRWTE - barrier sync, end wait */
/*
 *	these codes have to be distinct because some are used
 *	in switch statements
 */
#define RECOVER       32767    /* not used */
#define LIGHT         32766    /* not used */
#define REACQUIRE     32765    /* not used */
#define GNWAIT        32759    /* not used */
#define GNRESUME      32758    /* not used */
#define GWAIT         32757    /* not used */
#define GRESUME       32756    /* not used */
#define SINIT         32755    /* not used */
#define MSTARTF       32754    /* not used */
#define MWAITF        32753    /* not used */
#define MRESUMEF      32752    /* not used */
#define CSWAIT        32751    /* not used */
#define CSNWAIT       32750    /* not used */
#define CSRESUME      32749    /* not used */
#define SWAITW        32748    /* not used */
#define SSTARTF       32747    /* not used */
#define SEXIT         32746    /* not used */

#define LOST		1023	/* Logging items lost */
#endif CRAYTRACE


#define PIX_SCR		(0xC << 1)
#define INSUBTREE	((subtree) && ((sx != 0) || (sy != 0)))
