static char sccs_externvars_h[] = "@(#)externvars.h	1.1 10/16/90 11:11:04 LLNL ";
#include <stdio.h>
#include "defines.h"
/***********************************************************************
 * This file defines the external references to (*MOST*) of the global
 * variables for the gmat tool
 * 
 **********************************************************************/

/* ******************************************************************** */
/*   (c) Copyright 1987 the Regents of the University of California,	*/
/*    Lawrence Livermore National Laboratory.  All Rights Reserved.	*/
/* ******************************************************************** */


/*
 * Copyright Cray Research, Inc.  Unpublished.  All rights reserved.

 * Cray Research warrants and provides support for this software
 * only when distributed and used under the terms of a license
 * agreement with Cray Research.

 * FOR PRODUCT DISTRIBUTED IN ANY OTHER MANNER, CRAY RESEARCH DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL 
 * CRAY RESEARCH BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA
 * OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OF
 * THIS SOFTWARE.
*/

/* External Global Variable References */

extern int first_box;
extern int dt_index;			/* offset into cd table below	*/
					/* to get name of directory	*/
extern char *directory_table[128];	/* table of filenames notice hard
				     	   coded max */
extern int ft_index;			/* offset into file table below	*/
					/* to get name of trace file*/
extern int ft_val;			/* combine with ft_index */
extern char *file_table[128];		/* table of filenames notice hard
					     coded max */
extern int key_enable;			/* used to determine if the key can
					   be brought up in dynamic mode */
extern int done, go, filepresent;
extern int e_speed;
extern int histx,histy;
extern int oldx,oldy;			/* coords of old view box  */
extern int choice[6];			/* user-defined significant action numbers */
extern int leftid;			/* node id of left mse bttn, -1 == invalid node */
extern double aux_data[7];		/* all possible auxiliary data */

extern struct x_y {
    int x,y;
};

extern  struct status {
    struct x_y children;
    struct x_y position;
    int id;
    int pass;
    int constraint;
    int working;
};

extern struct status screen[75][56];   

extern struct status subtree_screen[75][56];  /* odd to make it easier */
extern int subtree_curr_id;

extern struct act_struct {
    int action;		/* action number */
    struct act_struct *next;
};

extern struct child_struct {
    int child_id;	/* id of child */
    struct child_struct *next;   /* ptr to next child */
};

extern struct task_struct {
    int x,y;            /* x,y coords of top corner of node in primary canvas */
    int stx,sty;	/* x,y coords of top corner of node in subtree canvas */
    int state;          /* state of task, as indicated by action number */
    int process;        /* process assigned to task else NULL */
    int parent;         /* task id of parent, -1 if info lost */
    int aux_item;	/* auxiliary info - wait waiting on, which task slave 
			   is working for, etc */
    int slave;		/* 0 if task is not a slave, else task # working for */
    int act_length;	/* number of actions received */
    struct act_struct *actions;
    struct act_struct *last;        /* ptr to last action number */
    struct child_struct *children;
};

extern struct task_struct  *tasks[MAXTASKS];   /* array of ptrs to tasks */

extern struct proc_struct {
    int state;		/* 0 = idle process
			   1 = suspended process
			   2 = reacquired process
			   3 = process bound to task
			   4 = process NOT bound to task */
    int task;		/* task process is bound to */
    int x,y;
    int pid;		/* see driver.c description*/
}; 
extern struct proc_struct procs[];    /* array of process structures */

/* global variables to load socket info into */
extern int curr_id;    /* task id of current task */
extern int curr_action;  /* action of current task */
extern int curr_process; /* process of current task */
extern int curr_events;  /* total number of events processed */
extern int curr_procs;   /* number of active processes */
extern int curr_tasks;   /* total number of tasks created */

extern int fp;		/* trace file descriptor */
extern FILE *df;		/* dump file */



