static char USMID[] = "@(#)key.c	1.1 10/16/90 11:11:34 LLNL ";
#ifdef sunview
#include <suntool/sunview.h>
#include <suntool/canvas.h>
#include "externvars.h"

/*************************************************************
 * This file contains the routines to bring up a window 
 * containing a key to the various symbols used by gmat.
 * 
 **************************************************************/

/* ******************************************************************** */
/*   (c) Copyright 1987 the Regents of the University of California,	*/
/*    Lawrence Livermore National Laboratory.  All Rights Reserved.	*/
/* ******************************************************************** */


/*
 * Copyright Cray Research, Inc.  Unpublished.  All rights reserved.

 * Cray Research warrants and provides support for this software
 * only when distributed and used under the terms of a license
 * agreement with Cray Research.

 * FOR PRODUCT DISTRIBUTED IN ANY OTHER MANNER, CRAY RESEARCH DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL 
 * CRAY RESEARCH BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA
 * OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OF
 * THIS SOFTWARE.
*/

extern Pixrect hollow;
extern Pixrect solid;
extern Pixrect master;
extern Pixrect wait_w;
extern Pixrect infray;
extern Pixrect punbind;
extern Pixrect pidle;
extern Pixrect psuspend;
extern Pixrect preacq;
extern Pixrect pbind;
short kim_choice[] = {
#include "icons/choice.node"
};
mpr_static(key_choice,NODEDIM,NODEDIM,1,kim_choice);
short kim_slave[] = {
#include "icons/key_slv.node"
};
mpr_static(key_slave,NODEDIM,NODEDIM,1,kim_slave);

extern Pixwin *kpw;
extern Frame  popup_key_frame;

prepare_key()
{
    char str[40];

    window_set(popup_key_frame,WIN_SHOW,FALSE,0);

/* overview nodes */
    pw_rop(kpw,51,11,3,3,PIX_SET,NULL,0,0);
    pw_text(kpw,70,15,PIX_SCR,0,"task is not bound to process");
    pw_rop(kpw,51,31,3,3,PIX_SET,NULL,0,0);
    pw_rop(kpw,50,30,5,5,PIX_NOT(PIX_DST),NULL,0,0);
    pw_text(kpw,70,35,PIX_SCR,0,"task is bound to process");
    pw_rop(kpw,52,50,2,5,PIX_SET,NULL,0,0);       /* draw vertical line */
    pw_text(kpw,70,55,PIX_SCR,0,"process is not bound");
    pw_rop(kpw,50,70,5,5,PIX_SET,NULL,0,0);      /* fill area */
    pw_rop(kpw,52,70,2,5,PIX_CLR,NULL,0,0);       /* draw vertical line */
    pw_text(kpw,70,75,PIX_SCR,0,"process is bound");

/* primary canvas nodes */
    pw_text(kpw,5,95,PIX_SCR,0,"UNBOUND");
    pw_text(kpw,350,95,PIX_SCR,0,"BOUND");

    pw_rop(kpw,10,105,NODEDIM,NODEDIM,PIX_SRC,&solid,0,0);
    pw_text(kpw,70,130,PIX_SCR,0,"task is ready");
    pw_rop(kpw,350,105,NODEDIM,NODEDIM,PIX_NOT(PIX_SRC),&solid,0,0);

    pw_rop(kpw,10,140,NODEDIM,NODEDIM,PIX_SRC,&master,0,0);
    pw_text(kpw,70,165,PIX_SCR,0,"enclosed task is a master");
    pw_rop(kpw,350,140,NODEDIM,NODEDIM,PIX_NOT(PIX_SRC),&master,0,0);

    pw_rop(kpw,10,175,NODEDIM,NODEDIM,PIX_SRC,&hollow,0,0);
    pw_text(kpw,70,200,PIX_SCR,0,"task is completed and recovered");

    pw_rop(kpw,10,210,NODEDIM,NODEDIM,PIX_SRC,&key_choice,0,0);
    pw_text(kpw,70,235,PIX_SCR,0,"task is in state N");
    pw_rop(kpw,350,210,NODEDIM,NODEDIM,PIX_NOT(PIX_SRC),&key_choice,0,0);

    pw_rop(kpw,10,245,NODEDIM,NODEDIM,PIX_SRC,&wait_w,0,0);
    pw_text(kpw,70,270,PIX_SCR,0,"slave is waiting for work");
    pw_rop(kpw,350,245,NODEDIM,NODEDIM,PIX_NOT(PIX_SRC),&wait_w,0,0);

    pw_rop(kpw,10,280,NODEDIM,NODEDIM,PIX_SRC,&key_slave,0,0);
    pw_text(kpw,70,305,PIX_SCR,0,"slave is in state N");
    pw_rop(kpw,350,280,NODEDIM,NODEDIM,PIX_NOT(PIX_SRC),&key_slave,0,0);

    pw_rop(kpw,10,315,NODEDIM,NODEDIM,PIX_SRC,&infray,0,0);
    pw_text(kpw,70,335,PIX_SCR,0,"slave is working");
    pw_rop(kpw,350,315,NODEDIM,NODEDIM,PIX_NOT(PIX_SRC),&infray,0,0);

    pw_text(kpw,70,365,PIX_SCR,0,"TASK AND SLAVE STATES");
    pw_text(kpw,30,385,PIX_SCR,0,"WT - Waiting on a task");
    pw_text(kpw,30,405,PIX_SCR,0,"WL - Waiting on a lock");
    pw_text(kpw,30,425,PIX_SCR,0,"WE - Waiting on an event");
    pw_text(kpw,30,445,PIX_SCR,0,"WB - Waiting on a barrier");
    pw_text(kpw,30,465,PIX_SCR,0,"WF - Waiting on a fray");
    pw_text(kpw,30,485,PIX_SCR,0,"GN - Waiting on guard N");
    pw_text(kpw,30,505,PIX_SCR,0,"G  - Waiting on a guard");
    pw_text(kpw,30,525,PIX_SCR,0,"CS - Waiting on a control structure");

    pw_text(kpw,5,550,PIX_SCR,0,"User-Defined Significant Action Numbers (0 = undefined)");
    sprintf(str,"Choice 1: Action Number %d",choice[1]);
    pw_text(kpw,105,565,PIX_SCR,0,str);
    sprintf(str,"Choice 2: Action Number %d",choice[2]);
    pw_text(kpw,105,580,PIX_SCR,0,str);
    sprintf(str,"Choice 3: Action Number %d",choice[3]);
    pw_text(kpw,105,595,PIX_SCR,0,str);
    sprintf(str,"Choice 4: Action Number %d",choice[4]);
    pw_text(kpw,105,610,PIX_SCR,0,str);
    sprintf(str,"Choice 5: Action Number %d",choice[5]);
    pw_text(kpw,105,625,PIX_SCR,0,str);

/* process icons */
    pw_rop(kpw,10,635,48,48,PIX_NOT(PIX_SRC),&pbind,0,0);
    pw_text(kpw,65,660,PIX_SCR,0,"process is bound");
    pw_rop(kpw,210,635,PROCDIM,PROCDIM,PIX_SRC,&pidle,0,0);
    pw_text(kpw,260,660,PIX_SCR,0,"process is idle");
    pw_rop(kpw,10,680,PROCDIM,PROCDIM,PIX_SRC,&psuspend,0,0);
    pw_text(kpw,60,705,PIX_SCR,0,"process is suspended");
    pw_rop(kpw,210,680,PROCDIM,PROCDIM,PIX_SRC,&preacq,0,0);
    pw_text(kpw,255,705,PIX_SCR,0,"process is reacquired");
    pw_rop(kpw,10,725,PROCDIM,PROCDIM,PIX_SRC,&punbind,0,0);
    pw_text(kpw,60,750,PIX_SCR,0,"process is unbound");
}
#endif
