static char USMID[] = "@(#)winit.c	1.1 10/16/90 11:11:47 LLNL ";
#ifdef sunview
#include <suntool/sunview.h>
#include <suntool/panel.h>
#include <suntool/canvas.h>
#include <suntool/scrollbar.h>
#include <suntool/textsw.h>
#include "externvars.h"

/**********************************************************************
 * This file contains the routines static_init() and dynamic_init(),
 * which initilize the windows and defines their placement.
 *
 **********************************************************************/

/* ******************************************************************** */
/*   (c) Copyright 1987 the Regents of the University of California,	*/
/*    Lawrence Livermore National Laboratory.  All Rights Reserved.	*/
/* ******************************************************************** */
 

/*
 * Copyright Cray Research, Inc.  Unpublished.  All rights reserved.

 * Cray Research warrants and provides support for this software
 * only when distributed and used under the terms of a license
 * agreement with Cray Research.

 * FOR PRODUCT DISTRIBUTED IN ANY OTHER MANNER, CRAY RESEARCH DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL 
 * CRAY RESEARCH BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA
 * OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OF
 * THIS SOFTWARE.
*/

extern char dumpfile[];
extern Pixwin *pw, *pw2, *pwf, *kpw, *stpw, *mpw;
extern Frame frame,popup_frame,popup_key_frame,subtree_frame,misc_frame;
extern Panel panel;
extern Canvas canvas,pop_canvas,canvas_full,key_canvas,subtree_canvas,misc_canvas;
extern Scrollbar h_bar, stv_bar, sth_bar;
extern Scrollbar pch_bar, pcv_bar;  
extern Textsw textsw;
extern Panel_item title, event_count, process_count, 
  go_button, connect_button, load_button, quit_button,
  file_choice, directory_choice, subtree_button,path_button,
  step_button,key_button,histogram_button,
  task_count, e_speed_slider;
void load_notify_proc(), go_notify_proc(), hist_notify_proc(),
  stop_notify_proc(), quit_notify_proc(), e_speed_notify_proc(),
  step_notify_proc(), connect_notify_proc(),
  subtree_notify_proc(), key_notify_proc(),
  directory_notify_proc(),file_notify_proc(),
  handle_pcevent(),handle_ovevent(),handle_miscevent();

unsigned short icon_image[256] = {
#include "icons/sg.icon"
};
DEFINE_ICON_FROM_IMAGE(icon, icon_image);

static_init()
{
    int i;
    struct pixfont *title_font, *textsw_font;
    
    /* Create the main window. */
    frame = window_create(NULL,FRAME,
			  FRAME_ICON,	&icon,
			  WIN_WIDTH,	960,
			  WIN_HEIGHT,	900,
			  WIN_X,	0,
			  WIN_Y,	0,
			  0);

    /* Create the panel sub-window and all of its goodies. */
    textsw_font = pf_open("/usr/lib/fonts/fixedwidthfonts/screen.r.12");
    panel = window_create(frame,PANEL,
			  WIN_WIDTH,	560,
			  WIN_HEIGHT,	178,
			  WIN_X,	0,
			  WIN_Y,	0,
			  WIN_FONT,	textsw_font,
			  0);
    
    /* Create the PopUp window for the histograms. */
    popup_frame = window_create(frame,FRAME,
				      WIN_HEIGHT,	230,
				      WIN_WIDTH,	800,
				      WIN_X,		50,
				      WIN_Y,		660,
				      FRAME_LABEL,
				"       GMAT Histogram - Events Procesed versus Active Processes",
				      0);
    window_fit(popup_frame);

    /* Create the PopUp window for the key */
    popup_key_frame = window_create(frame,FRAME,
				    WIN_WIDTH,		420,
				    WIN_HEIGHT,		800,
				    WIN_X,		550,
				    WIN_Y,		80,
				    FRAME_LABEL,	"              Key to GMAT Symbols",
				    0);
    window_fit(popup_key_frame);

    /* Create the PopUp window for the subtree */
    subtree_frame = window_create(frame,FRAME,
				  WIN_WIDTH,		960,
				  WIN_HEIGHT,		300,
				  WIN_X,		0,
				  WIN_Y,		575,
				  FRAME_LABEL,		"             Subtree Canvas",
				  0);
    window_fit(subtree_frame);

    /* Create the PopUp window for node info and other misc. items */
    misc_frame = window_create(frame,FRAME,
			       WIN_WIDTH,		INFOX,
			       WIN_HEIGHT,		INFOY,
			       0);
    window_fit(misc_frame);

    title_font = pf_open("/usr/lib/fonts/fixedwidthfonts/gallant.r.19");
    title = panel_create_item(panel, PANEL_MESSAGE,
			      PANEL_ITEM_X,		100,
			      PANEL_ITEM_Y,		1,
			      PANEL_LABEL_STRING,	"GMAT State Graph - Static Mode",
			      PANEL_LABEL_FONT,	title_font,
			      0);
    directory_choice = panel_create_item(panel, PANEL_CHOICE,
					 PANEL_ITEM_X,		10,
					 PANEL_ITEM_Y,		20,
/*					 PANEL_CHOICE_STRINGS,  "", 0, */
					 PANEL_LABEL_STRING,	"Directory: ",
					 PANEL_DISPLAY_LEVEL,	PANEL_NONE,
					 PANEL_NOTIFY_PROC,	directory_notify_proc,
					 0);
    file_choice = panel_create_item(panel, PANEL_CHOICE,
				    PANEL_ITEM_X,		10,
				    PANEL_ITEM_Y,		40,
				    PANEL_LABEL_X,		10,
				    PANEL_LABEL_Y,		40,
				    PANEL_CHOICE_Y,		0, 40,
/*				    PANEL_CHOICE_STRINGS,       "", 0, */
				    PANEL_LABEL_STRING,		"Trace file: ",
				    PANEL_DISPLAY_LEVEL,	PANEL_CURRENT,
				    PANEL_NOTIFY_PROC,		file_notify_proc,
				    0);
    file_table[0] = NULL;
    directory_table[0] = NULL;
    load_directory_table();

    e_speed_slider = panel_create_item(panel, PANEL_SLIDER,
				       PANEL_ITEM_X,	        10,
				       PANEL_ITEM_Y,	        65,
				       PANEL_VALUE,		100,
				       PANEL_MIN_VALUE,	        0,
				       PANEL_MAX_VALUE,	        100,
				       PANEL_SLIDER_WIDTH,	300,
				       PANEL_SHOW_RANGE,	TRUE,
				       PANEL_SHOW_VALUE,	TRUE,
				       PANEL_LABEL_STRING,	"Event Speed (%)",
				       PANEL_NOTIFY_PROC,	e_speed_notify_proc,
				       0);
    event_count = panel_create_item(panel, PANEL_MESSAGE,
				    PANEL_ITEM_Y,	95,
				    PANEL_ITEM_X,	10,
				    PANEL_LABEL_STRING, 	"Events Processed: 0",
				    0);
    process_count = panel_create_item(panel, PANEL_MESSAGE,
				      PANEL_ITEM_Y,	95,
				      PANEL_ITEM_X,	350,
				      PANEL_LABEL_STRING,	"Active Processes: 0",
				      0);
    task_count = panel_create_item(panel, PANEL_MESSAGE,
				   PANEL_ITEM_Y,		115,
				   PANEL_ITEM_X,		10,
				   PANEL_LABEL_STRING,		"Number of Tasks: 0",
				   0);
    load_button = panel_create_item(panel, PANEL_BUTTON,
				    PANEL_ITEM_Y,	ATTR_ROW(7),
				    PANEL_ITEM_X,	ATTR_COL(2),
				    PANEL_LABEL_IMAGE, 
				    panel_button_image(panel,"Load",0,NULL),
				    PANEL_NOTIFY_PROC,	load_notify_proc,
				    0);
    go_button = panel_create_item(panel, PANEL_BUTTON,
				  PANEL_ITEM_Y,	ATTR_ROW(7),
				  PANEL_ITEM_X,	ATTR_COL(9),
				  PANEL_LABEL_IMAGE, 
				  panel_button_image(panel,"Go",0,NULL),
				  PANEL_NOTIFY_PROC,	go_notify_proc,
				  0);
    step_button =  panel_create_item(panel, PANEL_BUTTON,
				     PANEL_ITEM_Y,	ATTR_ROW(7),
				     PANEL_ITEM_X,	ATTR_COL(14),
				     PANEL_LABEL_IMAGE, 
				     panel_button_image(panel,"Step",0,NULL),
				     PANEL_NOTIFY_PROC,	step_notify_proc,
				     0);
    key_button = panel_create_item(panel, PANEL_BUTTON,
				   PANEL_ITEM_Y,	ATTR_ROW(7),
				   PANEL_ITEM_X,	ATTR_COL(21),
				   PANEL_LABEL_IMAGE, 
				   panel_button_image(panel,"Key",0,NULL),
				   PANEL_NOTIFY_PROC,	key_notify_proc,
				   0);
    subtree_button =  panel_create_item(panel, PANEL_BUTTON,
					PANEL_ITEM_Y,	ATTR_ROW(7),
					PANEL_ITEM_X,	ATTR_COL(27),
					PANEL_LABEL_IMAGE, 
					panel_button_image(panel,"Subtree",0,NULL),
					PANEL_NOTIFY_PROC,	subtree_notify_proc,
					0);
    histogram_button = panel_create_item(panel, PANEL_BUTTON,
					 PANEL_ITEM_Y,	ATTR_ROW(7),
					 PANEL_ITEM_X,	ATTR_COL(37),
					 PANEL_LABEL_IMAGE, 
					 panel_button_image(panel,"Histogram",0,NULL),
					 PANEL_NOTIFY_PROC,	hist_notify_proc,
					 0);
    quit_button = panel_create_item(panel, PANEL_BUTTON,
				    PANEL_ITEM_Y,	ATTR_ROW(7),
				    PANEL_ITEM_X,	ATTR_COL(70),
				    PANEL_LABEL_IMAGE, 
				    panel_button_image(panel,"Quit",0,NULL),
				    PANEL_NOTIFY_PROC,	quit_notify_proc,
				    0);

    /* Create the Canvas subwindow to view the full tree */
    canvas_full = window_create(frame,CANVAS,
				WIN_WIDTH,		384,
				WIN_HEIGHT,		283,
				WIN_X,			565,
				WIN_Y,			0,
				WIN_EVENT_PROC,		handle_ovevent,
				CANVAS_AUTO_SHRINK,	FALSE,
				0);
    pwf = canvas_pixwin(canvas_full); 

    /* Create the Text SubWindow. */
    textsw = window_create(frame, TEXTSW,
			   TEXTSW_FONT, 		textsw_font,
			   WIN_WIDTH,			560,
			   WIN_HEIGHT,			100,
			   WIN_X,			0,
			   WIN_Y,			183,
			   0); 

    /* Create the Canvas SubWindow. */
    canvas = window_create(frame,CANVAS,
			   CANVAS_WIDTH,		3800,
			   CANVAS_HEIGHT,		2800,
			   WIN_WIDTH,			VIEWWIDTH,
			   WIN_HEIGHT,			VIEWHEIGHT,
			   WIN_X,			0,
			   WIN_Y,			288,
			   CANVAS_AUTO_SHRINK,		FALSE,
			   WIN_VERTICAL_SCROLLBAR,
			   pcv_bar = scrollbar_create(SCROLL_BUBBLE_DISPLAY_LEVEL, SCROLL_NEVER,
						      SCROLL_BAR_DISPLAY_LEVEL, SCROLL_NEVER,
						      0),
			   WIN_HORIZONTAL_SCROLLBAR,
			   pch_bar = scrollbar_create(SCROLL_BAR_DISPLAY_LEVEL, SCROLL_NEVER, 
						      SCROLL_BUBBLE_DISPLAY_LEVEL, SCROLL_NEVER,
						      0),
			   WIN_EVENT_PROC, 		handle_pcevent,
			   0);
    pw = canvas_pixwin(canvas);

    /* create the histogram SubWindow */
    pop_canvas = window_create(popup_frame,CANVAS,
			       CANVAS_WIDTH,	MAXHIST,
			       CANVAS_HEIGHT,	300,
			       CANVAS_AUTO_SHRINK,	FALSE,
			       WIN_HORIZONTAL_SCROLLBAR,h_bar=scrollbar_create(0),
			       0);
    pw2 = canvas_pixwin(pop_canvas);

    /* create the key SubWindow */
    key_canvas = window_create(popup_key_frame,CANVAS,
			       CANVAS_WIDTH,    420,
			       CANVAS_HEIGHT,	800,
			       CANVAS_AUTO_SHRINK,	FALSE,
			       0);
    kpw = canvas_pixwin(key_canvas);

    /* create the subtree SubWindow */
    subtree_canvas = window_create(subtree_frame,CANVAS,
				   CANVAS_WIDTH,	3800,
				   CANVAS_HEIGHT,	2800,
				   CANVAS_AUTO_SHRINK,	FALSE,
				   WIN_HORIZONTAL_SCROLLBAR, sth_bar = scrollbar_create(0),
				   WIN_VERTICAL_SCROLLBAR,   stv_bar = scrollbar_create(0),
				   0);
    stpw = canvas_pixwin(subtree_canvas);

    /* create the misc SubWindow */
    misc_canvas = window_create(misc_frame,CANVAS,
				CANVAS_WIDTH,		INFOX,
				CANVAS_HEIGHT,		INFOY,
				CANVAS_AUTO_SHRINK,	FALSE,
				WIN_EVENT_PROC, 	handle_miscevent,
				0);
    mpw = canvas_pixwin(misc_canvas);

    display_message("No Active File\n");
}


dynamic_init()
{
    int i;
    struct pixfont *title_font, *textsw_font;
    char str[30];
    char current_dir[150];

    /* Create the main window. */
    frame = window_create(NULL,FRAME,
			  FRAME_ICON,	&icon,
			  WIN_WIDTH,	960,
			  WIN_HEIGHT,	900,
			  WIN_X,	0,
			  WIN_Y,	0,
			  0);

    /* Create the panel sub-window and all of its goodies. */
    textsw_font = pf_open("/usr/lib/fonts/fixedwidthfonts/screen.r.12");
    panel = window_create(frame,PANEL,
			  WIN_WIDTH,	560,
			  WIN_HEIGHT,	178,
			  WIN_X,	0,
			  WIN_Y,	0,
			  WIN_FONT,	textsw_font,
			  0);

    /* Create the PopUp window for the histograms. */
    popup_frame = window_create(frame,FRAME,
				WIN_HEIGHT,	230,
				WIN_WIDTH,	800,
				WIN_X,		50,
				WIN_Y,	 	660,
				FRAME_LABEL,
				"             GMAT Histogram - Events Processed versus Active Processes",
				0);
    window_fit(popup_frame);

    /* Create the PopUp window for the key */
    popup_key_frame = window_create(frame,FRAME,
				    WIN_WIDTH,		420,
				    WIN_HEIGHT,		800,
				    WIN_X,		550,
				    WIN_Y,		80,
				    FRAME_LABEL,	"                Key to GMAT Symbols",
				    0);
    window_fit(popup_key_frame);

    /* Create the PopUp window for the subtree */
    subtree_frame = window_create(frame,FRAME,
				  WIN_WIDTH,		960,
				  WIN_HEIGHT,		300,
				  WIN_X,		0,
				  WIN_Y,		575,
				  FRAME_LABEL,		"             Subtree Canvas",
				  0);
    window_fit(subtree_frame);

    /* Create the PopUp window for node info and other misc. items */
    misc_frame = window_create(frame,FRAME,
			       WIN_WIDTH,		INFOX,
			       WIN_HEIGHT,		INFOY,
			       0);
    window_fit(misc_frame);

    title_font = pf_open("/usr/lib/fonts/fixedwidthfonts/gallant.r.19");
    title = panel_create_item(panel, PANEL_MESSAGE,
			      PANEL_ITEM_X,		100,
			      PANEL_ITEM_Y,		1,
			      PANEL_LABEL_STRING,	"GMAT State Graph - Dynamic Mode",
			      PANEL_LABEL_FONT,	title_font,
			      0);
    strcpy(current_dir,"Directory: ");
    getwd(current_dir + 11);
    directory_choice = panel_create_item(panel, PANEL_MESSAGE,
					 PANEL_ITEM_X,		10,
					 PANEL_ITEM_Y,		20,
					 PANEL_LABEL_STRING,	current_dir,
					 0);
    sprintf(str,"Dump file: %s ",dumpfile); 

    file_choice = panel_create_item(panel, PANEL_MESSAGE,
				    PANEL_ITEM_X,		10,
				    PANEL_ITEM_Y,		40,
				    PANEL_LABEL_X,		10,
				    PANEL_LABEL_Y,		40,
				    PANEL_CHOICE_Y,		0, 40,
				    PANEL_LABEL_STRING,		str,
				    0);
    event_count = panel_create_item(panel, PANEL_MESSAGE,
				    PANEL_ITEM_Y,	80,
				    PANEL_ITEM_X,	10,
				    PANEL_LABEL_STRING, 	"Events Processed: 0",
				    0);
    process_count = panel_create_item(panel, PANEL_MESSAGE,
				      PANEL_ITEM_Y,	80,
				      PANEL_ITEM_X,	350,
				      PANEL_LABEL_STRING,	"Active Processes: 0",
				      0);
    task_count = panel_create_item(panel, PANEL_MESSAGE,
				   PANEL_ITEM_Y,		100,
				   PANEL_ITEM_X,		10,
				   PANEL_LABEL_STRING,		"Number of Tasks: 0",
				   0);
    connect_button = panel_create_item(panel, PANEL_BUTTON,
				       PANEL_ITEM_Y,	ATTR_ROW(7),
				       PANEL_ITEM_X,	ATTR_COL(5),
				       PANEL_LABEL_IMAGE, 
				       panel_button_image(panel,"Connect",0,NULL),
				       PANEL_NOTIFY_PROC,	connect_notify_proc,
				       0);
    key_button = panel_create_item(panel, PANEL_BUTTON,
				       PANEL_ITEM_Y,	ATTR_ROW(7),
				       PANEL_ITEM_X,	ATTR_COL(16),
				       PANEL_LABEL_IMAGE, 
				       panel_button_image(panel,"Key",0,NULL),
				       PANEL_NOTIFY_PROC,	key_notify_proc,
				       0);
    subtree_button =  panel_create_item(panel, PANEL_BUTTON,
					PANEL_ITEM_Y,	ATTR_ROW(7),
					PANEL_ITEM_X,	ATTR_COL(23),
					PANEL_LABEL_IMAGE, 
					panel_button_image(panel,"Subtree",0,NULL),
					PANEL_NOTIFY_PROC,	subtree_notify_proc,
					0);
    histogram_button = panel_create_item(panel, PANEL_BUTTON,
					 PANEL_ITEM_Y,	ATTR_ROW(7),
					 PANEL_ITEM_X,	ATTR_COL(34),
					 PANEL_LABEL_IMAGE, 
					 panel_button_image(panel,"Histogram",0,NULL),
					 PANEL_NOTIFY_PROC,	hist_notify_proc,
					 0);
    quit_button = panel_create_item(panel, PANEL_BUTTON,
				    PANEL_ITEM_Y,	ATTR_ROW(7),
				    PANEL_ITEM_X,	ATTR_COL(60),
				    PANEL_LABEL_IMAGE, 
				    panel_button_image(panel,"Quit",0,NULL),
				    PANEL_NOTIFY_PROC,	quit_notify_proc,
				    0);

    /* Create the Canvas subwindow to view the full tree */
    canvas_full = window_create(frame,CANVAS,
				WIN_WIDTH,		383,
				WIN_HEIGHT,		283,
				WIN_X,			565,
				WIN_Y,			0,
				WIN_EVENT_PROC,		handle_ovevent,
				CANVAS_AUTO_SHRINK,	FALSE,
				0);
    pwf = canvas_pixwin(canvas_full); 

    /* Create the Text SubWindow. */
    textsw = window_create(frame, TEXTSW,
			   TEXTSW_FONT, 		textsw_font,
			   WIN_WIDTH,			560,
			   WIN_HEIGHT,			100,
			   WIN_X,			0,
			   WIN_Y,			183,
			   0); 
    /* Create the Canvas subwindow. */
    canvas = window_create(frame,CANVAS,
			   CANVAS_WIDTH,		3800,
			   CANVAS_HEIGHT,		2800,
			   WIN_WIDTH,			VIEWWIDTH,
			   WIN_HEIGHT,			VIEWHEIGHT,
			   WIN_X,			0,
			   WIN_Y,			288,
			   CANVAS_AUTO_SHRINK,		FALSE,
			   WIN_VERTICAL_SCROLLBAR,
			   pcv_bar = scrollbar_create(SCROLL_BUBBLE_DISPLAY_LEVEL, SCROLL_NEVER,
						      SCROLL_BAR_DISPLAY_LEVEL, SCROLL_NEVER,
						      0),
			   WIN_HORIZONTAL_SCROLLBAR,
			   pch_bar = scrollbar_create(SCROLL_BAR_DISPLAY_LEVEL, SCROLL_NEVER, 
						      SCROLL_BUBBLE_DISPLAY_LEVEL, SCROLL_NEVER,
						      0),
			   WIN_EVENT_PROC, 		handle_pcevent,
			   0);
    pw = canvas_pixwin(canvas);

    pop_canvas = window_create(popup_frame,CANVAS,
			       CANVAS_WIDTH,	MAXHIST,
			       CANVAS_HEIGHT,	300,
			       CANVAS_AUTO_SHRINK,	FALSE,
			       WIN_HORIZONTAL_SCROLLBAR,h_bar=scrollbar_create(0),
			       0);
    pw2 = canvas_pixwin(pop_canvas);

    key_canvas = window_create(popup_key_frame,CANVAS,
			       CANVAS_WIDTH,    420,
			       CANVAS_HEIGHT,	800,
			       CANVAS_AUTO_SHRINK,	FALSE,
			       0);
    kpw = canvas_pixwin(key_canvas);
#ifdef WINDEBUG
	printf("window_init kpw = (%d)", kpw);
#endif

    subtree_canvas = window_create(subtree_frame,CANVAS,
				   CANVAS_WIDTH,	3800,
				   CANVAS_HEIGHT,	2800,
				   CANVAS_AUTO_SHRINK,	FALSE,
				   WIN_HORIZONTAL_SCROLLBAR, sth_bar = scrollbar_create(0),
				   WIN_VERTICAL_SCROLLBAR,   stv_bar = scrollbar_create(0),
				   0);
    stpw = canvas_pixwin(subtree_canvas);

    display_message("Awaiting socket connect\n");
}
#endif
