static char sccs_xexterns_h[] = "@(#)xexterns.h	1.2 10/22/90 13:20:53 LLNL ";
#include <X11/X.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#ifdef X11R3
#include <X11/Form.h>
#include <X11/Label.h>
#include <X11/Command.h>
#include <X11/AsciiText.h>
#include <X11/Box.h>
#include <X11/Viewport.h>
#include <X11/Dialog.h>
#else
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Dialog.h>
#endif
/* #include <X11/Xlib.h>
#include <X11/VPaned.h>
#include <X11/Xatom.h> */


/*
 * Copyright Cray Research, Inc.  Unpublished.  All rights reserved.

 * Cray Research warrants and provides support for this software
 * only when distributed and used under the terms of a license
 * agreement with Cray Research.

 * FOR PRODUCT DISTRIBUTED IN ANY OTHER MANNER, CRAY RESEARCH DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL 
 * CRAY RESEARCH BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA
 * OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OF
 * THIS SOFTWARE.
*/

#define BUFFER_LENGTH 5120
#define maxArgs 15
#define VIEWSIZE 5000
#define EVENTSX		20
#define EVENTSY		120
#define ACTIVEX		400
#define ACTIVEY		120
#define TASKSX		20
#define TASKSY		140
#define SLIDERX		135
#define SLIDERY		90
#define ICONHEIGHT 47
#define ICONWIDTH  47

extern Widget frame;	      /* the main widget opened to X11 */
extern Widget panel;	      /* this panel contains all the other widgets */
extern Widget control_widget; /* the upper left control window */
extern Widget message_widget; /* the upper right text (message) window */
extern Widget hist_viewport;  /* histogram viewport widget */
extern Widget hist_shell;     /* histogram shell declaration for popup */
extern Widget inner_hist;
extern Widget outer_hist;
extern Widget title;	      /* "GMAT - timeline"  title line */
extern Widget dir_label;      /* directory label widget (not the command) */
extern Widget trace_label;    /* trace file label widget (not the command) */
extern Widget file_choice;    /* command button for selection trace file */
extern Widget file_command;    /* command button for selection trace file */
extern Widget directory_choice;  /* command button for selecting directory */
extern Widget dir_command;  /* command button for selecting directory */
extern Widget dir_pop;	      /* directory popup menu selection box */
extern Widget file_pop;	      /* trace file popup menu selection box */
extern Widget dir_shell;      /* directory shell declaration for popup */
extern Widget file_shell;      /* trace file shell declaration for popup */
extern Widget directory_selection_buttons[32];  /* directory selection table */
extern Widget key_pop;	       /* key popup box */
extern Widget key_shell;       /* key shell declaration for popup */
extern Widget outer_canvas;
extern Widget inner_canvas;
extern Widget viewport;
extern Widget subtree_frame;
extern Widget misc_frame;
extern Widget e_speed_slider;
extern Widget load_button;
extern Widget go_button;
extern Widget step_button;
extern Widget key_button;
extern Widget subtree_button;
extern Widget histogram_button;
extern Widget quit_button;
extern Widget canvas_full;
extern Widget textsw;
extern Widget canvas;
extern Widget subtree_shell;
extern Widget misc_shell;
extern Widget quit_shell;
extern Widget misc_shell;
extern Widget misc_canvas;
extern Widget scrollbar_label;
extern Widget e_speed_slider;
extern Widget node_pop;
extern Widget node_shell;
extern Widget outer_subtree;
extern Widget subtree_viewport;

extern Screen *canvas_screen;  /* screen definition for the canvas screen */
extern Screen *ov_screen;      /* screen definition for the overview canvas */
extern Screen *control_screen; /* screen definition for the control screen */
extern Screen *hist_screen;    /* screen definition for the histogram screen */
extern Screen *key_scr;        /* screen definition for the popup key */
extern Screen *node_screen;    /* screen definition for the popup node */

extern Display *display_control; /* display for communication with manager */
extern Display *canvas_display;  /* display definition:  == display_control */
extern Display *ov_display;      /* display definition:  == display_control */
extern Display *control_display; /* display definition:  == display_control */
extern Display *hist_display;    /* display definition:  == display_control */
extern Display *text_display;    /* display definition:  == display_control */
extern Display *key_display;     /* display definition:  == display_control */
extern Display *subtree_display; /* display definition:  == display_control */
extern Display *node_display;    /* display definition:  == display_control */

extern Window frame_wid;	  /* window definition for the toplevel frame */
extern Window can_win;	      /* window definition for the canvas window */
extern Window ov_win;	      /* window definition for the overview window */
extern Window control_win;    /* window definition for the control window */
extern Window hist_win;	      /* window definition for the histogram window */
extern Window text_win;	      /* window definition for the text window */
extern Window key_win;	      /* window definition for the key window */
extern Window subtree_win;    /* window definition for the subtree window */
extern Window node_win;       /* window definition for the node info window */

extern GC control_gc;	      /* graphics control for writing to control win. */
extern GC canvas_gc;	      /* graphics control for writing to canvas win. */
extern GC rv_gc;	      /* graphics control for rev-video to canvas win */
extern GC ov_gc;	      /* graphics control for writing to ov canvas */
extern GC box_gc;	      /* graphics control for writing box to ov canvas*/
extern GC erase_gc;	      /* graphics control for writing box to ov canvas*/
extern GC key_gc;	      /* graphics control for writing to key win. */
extern GC hist_gc;	      /* graphics control for writing to histogram */
extern GC node_gc;	      /* graphics control for writing to popup node */

extern XWindowAttributes frameAttributes;

extern int move_height;	      /* used to manage scrolling of canvas widget */
extern int move_hist;	      /* used to manage scrolling of historgram widget*/
extern caddr_t event_count;

extern void fileMenu();
extern void dirMenu();
extern void file_notify_proc();
extern void directory_notify_proc();
extern void e_speed_notify_proc();
extern void e_speed_notify_thumb();

extern Pixel black;
extern Pixel white;
extern int subtreeFLAG;
extern int histFLAG;
extern unsigned int depth;

Arg args[maxArgs];
